"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkSyntax = exports.checkSMTP = exports.checkMX = exports.checkEmail = void 0;
var mx_1 = require("./mx");
Object.defineProperty(exports, "checkMX", { enumerable: true, get: function () { return mx_1.checkMX; } });
var smtp_1 = require("./smtp");
Object.defineProperty(exports, "checkSMTP", { enumerable: true, get: function () { return smtp_1.checkSMTP; } });
var syntax_1 = require("./syntax");
Object.defineProperty(exports, "checkSyntax", { enumerable: true, get: function () { return syntax_1.checkSyntax; } });
var DEFAULT_RESULT = {
    reachable: false,
    syntax: { valid: false },
    mx: { valid: false },
    smtp: { valid: false },
};
function checkEmail(email, _a) {
    var _b = _a === void 0 ? {} : _a, fromAddr = _b.fromAddr;
    return __awaiter(this, void 0, void 0, function () {
        var result, syntax, mx, records, smtp;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    result = __assign({ email: email }, DEFAULT_RESULT);
                    syntax = (0, syntax_1.checkSyntax)(email);
                    if (!syntax.valid) {
                        return [2 /*return*/, __assign(__assign({}, result), { syntax: syntax })];
                    }
                    return [4 /*yield*/, (0, mx_1.checkMX)(syntax.domain)];
                case 1:
                    mx = _c.sent();
                    if (!mx.valid || !mx.mxRecords) {
                        return [2 /*return*/, __assign(__assign({}, result), { syntax: syntax, mx: mx })];
                    }
                    records = mx.mxRecords.sort(function (a, b) { return a.priority - b.priority; });
                    return [4 /*yield*/, (0, smtp_1.checkSMTP)(email, records[0].exchange, 25, { fromAddr: fromAddr })];
                case 2:
                    smtp = _c.sent();
                    if (!smtp.valid) {
                        return [2 /*return*/, __assign(__assign({}, result), { syntax: syntax, mx: mx, smtp: smtp })];
                    }
                    return [2 /*return*/, __assign(__assign({}, result), { reachable: true, syntax: syntax, mx: mx, smtp: smtp })];
            }
        });
    });
}
exports.checkEmail = checkEmail;
//# sourceMappingURL=index.js.map